<!DOCTYPE html>
<html lang="en">
<head>
  <title>Task63.20</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Voucher</h2>
  <div class="row">
	<div class="col-sm-12">
		<button id="btn-clear-data" class="btn btn-danger">Delete All Data</button>
	</div>
  </div>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="voucher-code">Mã Voucher</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Phần trăm giảm giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class = "col-sm-3">
		</div>
		<div class="col-sm-3">
		  <button id="btn-update-voucher" class="btn btn-info">Update Voucher</button>
		</div>
		<div class="col-sm-3">
			<button id="btn-delete-voucher" class="btn btn-danger">Delete Voucher</button>
		</div>
		<div class="col-sm-3">
			<button id="btn-create-voucher" class="btn btn-success">Add New Voucher</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã giảm giá</th>
        <th>Phần trăm giảm giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
      </tr>
  </table>
</div>
<script>
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id voucher đang đc update or delete. Mặc định = 0;
var gVoucherId = 0;
const gBASE_URL = "http://localhost:8080/vouchers/";
const gCONTENT_TYPE = "application/json;charset=UTF-8";

$(document).ready(function(){
	var table = $("#user-table").DataTable({
		"columns": [
			{"data":"id"},
			{"data":"maVoucher"},
			{"data":"phanTramGiamGia"},
			{"data":"ghiChu"},
			{"data":"ngayTao"},
			{"data":"ngayCapNhat"},
		]
	})
	$.ajax({
		url: gBASE_URL,
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.responseText);
		}
	})
		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#user-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update voucher: add event to save data button
	$("#btn-update-voucher").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new voucher
	$("#btn-create-voucher").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete voucher selected
	$("#btn-delete-voucher").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Delete all vouchers
	$("#btn-clear-data").on("click",function(){
		onDeleteAllBtnClick();
	});
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gVoucherId = $(paramRow).find("td:eq(0)").html();
		console.log("Voucher id of selected row: " + gVoucherId);
		//lấy thông tin voucher của row được click và hiển thị lên form
		var vVoucher = callApiGetVoucherById(gVoucherId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo voucher obj
		var vVoucherObj = {
			maVoucher: "",
			phanTramGiamGia: -1,
			ghiChu:"",
		}
		// B1: Thu thập dữ liệu
		getUpdateVoucherData(vVoucherObj);
		// B2: Validate update
		var vIsVoucherValidate = validateVoucherData(vVoucherObj);
    	if (vIsVoucherValidate){
			// B3: update voucher
			$.ajax({
				url: gBASE_URL + gVoucherId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vVoucherObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateVoucherSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm voucher
	function onCreateButtonClick(){
		//khai báo voucher obj
		var vVoucherObj = {
			maVoucher: "",
			phanTramGiamGia: -1,
			ghiChu:"",
		}
		// B1: Thu thập dữ liệu
		getUpdateVoucherData(vVoucherObj);
		// B2: Validate data
		var vIsVoucherValidate = validateVoucherData(vVoucherObj);
    	if (vIsVoucherValidate){
			// B3: create voucher
			$.ajax({
				url: gBASE_URL,
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vVoucherObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreateVoucherSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa voucher được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: gBASE_URL + gVoucherId,
        type: "DELETE",
        success: function(paramRes) {
          handleDeleteVoucherSuccess();
        },
        error: function(paramErr) {
          alert("Xóa voucher không thành công");
        }
      });
	}
	function onDeleteAllBtnClick(){
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: gBASE_URL,
        type: "DELETE",
        success: function(paramRes) {
          alert("Tất cả các vouchers trong database đã được xóa!");
        },
        error: function(paramErr) {
          alert("Xóa database không thành công");
        }
      });
	}
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
	//hàm gọi API lấy thông tin voucher của dòng được chọn
	function callApiGetVoucherById(paramId){
		$.ajax({
			url: gBASE_URL + paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayVoucherData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin voucher của dòng được click
	function displayVoucherData(paramVoucher){
		$("#input-voucher-code").val(paramVoucher.maVoucher);
		$("#input-discount").val(paramVoucher.phanTramGiamGia); 
		$("#input-note").val(paramVoucher.ghiChu); 
		$("#input-createDate").val(paramVoucher.ngayTao); 
		$("#input-updateDate").val(paramVoucher.ngayCapNhat);  
	}
	// hàm thu thập dữ liệu để update voucher
	function getUpdateVoucherData(paramVoucherObj) {
		paramVoucherObj.maVoucher =$("#input-voucher-code").val().trim();
		paramVoucherObj.phanTramGiamGia = parseInt($("#input-discount").val()); 
		paramVoucherObj.ghiChu = $("#input-note").val().trim(); 
	}

	// hàm validate data
	function validateVoucherData(paramVoucherObj) {
		if (paramVoucherObj.maVoucher === "") {
		alert("Cần nhập mã voucher");
		return false;
		}
		if (isNaN(paramVoucherObj.phanTramGiamGia)) {
		alert("Phần trăm giảm giá cần nhập vào phải là số");
		return false;
		}
		if (paramVoucherObj.phanTramGiamGia < 0 || paramVoucherObj.phanTramGiamGia > 100) {
		alert("Phần trăm giảm giá phải nhập trong khoảng từ 0 đến 100!");
		return false;
		}

		return true;
	}
	
	//hiển thị cập nhật voucher thành công
	function handleUpdateVoucherSuccess(){
		alert("Sửa voucher có id: " + gVoucherId + " thành công!");
	};
	//hiển thị thêm voucher thành công
	function handleCreateVoucherSuccess(){
		alert("Thêm voucher thành công!");
	};
	//hiển thị cập nhật voucher thành công
	function handleDeleteVoucherSuccess(){
		alert("Xóa voucher có id: " + gVoucherId + " thành công!");
	};
})
</script>
</body>
</html>
